# README


## Requirements

`Python3.9` is expected for this program because currently the CPLEX solver being used expects that version of Python.

To install the non-CPLEX dependencies, use `pip install -r requirements.txt`.

To install CPLEX, visit the IBM website and navigate to the proper license (student, academic, professional, etc.), and follow the installation guide provided by IBM.

## Running Example Script

If dependencies are installed you should be able to run:
* `example_doubly_constrained.py`: experiment on the adult dataset.  



## Running your Own Tests

To run one of your own tests, edit the following three things:

1. Create an entry in `example_config.ini`. An entry begins with `[your_title]` and contains all the fields specified by the example.

2. Change the objective in `dataset_configs.ini` if you desire.

3. Run the example script using your specifications instead of example by running `python example.py your_title`.



## Description of Output Format

The output from a trial will be wriiten to a csv file under the Results folder 


## Refernces 
This code is based on:
1-"Fair Algorithms for Clustering":  https://github.com/nicolasjulioflores/fair_algorithms_for_clustering
2-"Fair Range k-center":  https://github.com/thydnguyen/rangeFairKcenter 




